#
# Cannon
#

set Bullet 0
set CannonFlg 0
set BulletID 0
set Bullet_cnt 0
set Bullet_ang 45

proc vs_H_Event_PickSW { obj event userdata } {
	global vsTrue vsContinue
	global CannonFlg

	# vsMessageDlg "CannonFlg: $CannonFlg"

	if { $CannonFlg == 4 } {
		return $vsContinue
	}

	set val [ expr $userdata - $CannonFlg ]
	if { $val == 1 } {
		incr CannonFlg
		# sound on
		vsPlayAmbientSoundByName sound_pingpong 0
	} else {
		set CannonFlg 0
		# sound on
		vsPlayAmbientSoundByName sound_buu 0
	}
#	vsMessageDlg "Flg: $CannonFlg"

	# Shoot!!
	if { $CannonFlg == 3 } {
		ShootBulletOK $obj $event $userdata
	}
	return $vsContinue
}
proc ShootBulletOK { obj event userdata } {
	global vsTrue

	if [vscpAmIMaster == $vsTrue] {
		# I am Master
		ShootBullet $obj $event $userdata
		vscpSendApplSpecificMsg $obj "ShootBullet" "$userdata"
	} {
		# I am Slave
		vscpSendApplSpecificMsg $obj \
			"ShootBulletOK" "$userdata"
	}
}

proc ShootBullet { obj event userdata } {
	global vsCSWorld vsRelative vsCSLocal vsAbsolute
	global vsContinue vsPeriodicTask vsTclScript
	global Bullet Bullet_cnt BulletID
	global CannonFlg

	if { $Bullet == 0 } {
		set Bullet [ vsGetObjByName "Cannon.Bullet" ]
	}
	set BulletID [ vsAddTimeOutHandler $Bullet 300 $vsTclScript "" vs_H_PeriodicCannon $userdata $vsPeriodicTask ]

	set CannonFlg 4

	# sound on
	vsPlayAmbientSoundByName sound_bang 0
}
proc vs_H_PeriodicCannon { obj event userdata } {
	global vsCSWorld vsRelative vsContinue vsCSLocal vsAbsolute
	global vsContinue vsPeriodicTask vsTclScript
	global Bullet BulletID CannonFlg
	global Bullet_cnt vsStop Bullet_ang

	vsObjectRotateAngle $Bullet  $Bullet_ang 0.0 0.0 $vsCSWorld $vsAbsolute
	vsTranslate $Bullet 0 5 0 $vsCSLocal $vsRelative

	if { $Bullet_cnt >= 30 } {

		vsRemoveTimeOutHandler $Bullet $BulletID

		# to return origin
		set BulletID [ vsAddTimeOutHandler $Bullet 300 $vsTclScript "" vs_H_PeriodicReturnCannon $userdata $vsPeriodicTask ]
		vsRotateAngle $Bullet 0 0 0 $vsCSWorld $vsAbsolute
		set Bullet_cnt 0
		
		return $vsStop
	}
	incr Bullet_cnt
	set Bullet_ang [ expr $Bullet_ang + 3 ]

	return $vsContinue
}

proc vs_H_PeriodicReturnCannon { obj event userdata } {
	global vsCSWorld vsRelative vsContinue vsCSLocal vsAbsolute
	global Bullet BulletID CannonFlg
	global Bullet_cnt vsStop Bullet_ang

	vsTranslate $Bullet 0 0 -4 $vsCSLocal $vsRelative

	if { $Bullet_cnt >= 30 } {

		vsRemoveTimeOutHandler $Bullet $BulletID

		# reset bullet
		vsTranslate $Bullet 0 0 -80 $vsCSWorld $vsAbsolute
		vsRotateAngle $Bullet 0 0 0 $vsCSWorld $vsAbsolute
		set CannonFlg 0
		set Bullet_cnt 0
		set Bullet_ang 45

		return $vsStop
	}
	incr Bullet_cnt

	return $vsContinue
}





