# This is a sample script for event handler.

set bRotating 0
set timeoutHandler 0

proc myPeriodicRotate { obj event userData } {
    global vsCSLocal
    global vsRelative
    global vsContinue
    global bRotating

    vsRotateAngle $obj  0.0 10.0 10.0 $vsCSLocal $vsRelative
    return $vsContinue
}

proc myClickRotate { obj event userData } {
   global bRotating  
   global timeoutHandler
   global vsTclScript
   global vsPeriodicTask

  if {$bRotating == 0} {
    set bRotating 1
    set timeoutHandler [vsAddTimeOutHandler $obj 250 $vsTclScript "" myPeriodicRotate 0 $vsPeriodicTask]
  } elseif {$bRotating == 1} {
    set bRotating 0
    vsRemoveTimeOutHandler $obj $timeoutHandler
  }
}

